"""
Line
"""

import numpy as np
import pyfits as pf
from math import *

class line:

    """Represents an absorption or emission line. It is defined by its name, a wavelength, a typical width and its amplitude"""
    def __init__(self, name, restangst, restwidth = 25.0, height = 50.0, strength = 0, plotlinewidth=1.0):
        self.name = name
        self.z = 0.0
        self.restangst = restangst#average wavelength at z = 0
        self.angst = restangst #average wavelength at z != 0
        self.restwidth = restwidth#FWHM at z = 0
        self.width = restwidth #FWHM at z != 0
        self.height = height #peak amplitude
        self.strength = strength
        self.plotlinewidth = 1.0
        
    def setz(self,z):
        """sets the redshift of the line (changes its wavelength and its width)"""
        self.z = z
        self.angst = self.restangst * (1 + z)
        self.width = self.restwidth * (1 + z)

    def flux_gauss(self, l):
        """give me a wavelength l, I return the corresponding flux for a gaussian profile"""
    
        return self.height*np.exp(-4*log(2)*((l-self.angst)/self.width)**2)
